//pngfunc.c

#include "png.h"
#include "pngfunc.h"
#include "wsserver.h"
#include "wsfunc.h"

uint8_t				flagNew;

/*
формирование данных для отсылки картинки для передачи
по websocket
*/
int wsscreenPNG(uint8_t * wsd, uint8_t *bd, uint32_t wSz)
{
	int64_t	wsz 	= (int64_t)wSz;
	uint8_t	flg	= 0;
	uint8_t	dbyte;
	uint8_t	*ad;
	if(flagNew)
	{
		//printf("----sz:%i\n", wsz);
		//wsz = (int64_t)(bhfi.bfSize);	//размер файла PNG
		(*(uint8_t*)(wsd))	= WS_OPCODE_BINARY | FIN1;
		if(wsz < 126)
		{
			int8_t	cnt8 	= 0;
			(*(uint8_t*)(wsd + 1))	= (uint8_t)(wsz);
			//pthread_mutex_lock(&BMPmutex);
			//wmutlock(mt);
			while(cnt8 < wsz)
			{
				dbyte  = (*(uint8_t*)(bd + cnt8));
				ad	= cnt8 + wsd + 2;
				if(dbyte != (*(uint8_t*)(ad)))
				{
					flg = 0xFF;
					(*(uint8_t*)(ad))	= dbyte;
				}
				cnt8++;
			}
			//pthread_mutex_unlock(&BMPmutex);
			//wmutunlock(mt);
			if(flg)
				return (wsz + 2);
		}
		else if(wsz < 65535)
		{
			int32_t	cnt16 	= 0;
			(*(uint8_t*)(wsd + 1)) 	= 126;
			(*(uint8_t*)(wsd + 2)) 	= (uint8_t)((wsz >> 8) & 0xFF);
			(*(uint8_t*)(wsd + 3)) 	= (uint8_t)(wsz & 0xFF);
			//pthread_mutex_lock(&BMPmutex);
			//wmutlock(mt);
			while(cnt16 < wsz)
			{
				dbyte  = (*(uint8_t*)(bd + cnt16));
				ad	= cnt16 + wsd + 4;
				if(dbyte != (*(uint8_t*)(ad)))
				{
					flg = 0xFF;
					(*(uint8_t*)(ad))	= dbyte;
				}
				cnt16++;
			}
			//pthread_mutex_unlock(&BMPmutex);
			//wmutunlock(mt);
			if(flg)
				return (wsz + 4);
		}
		else
		{
			int64_t	cnt64 	= 0;
			(*(uint8_t*)(wsd + 1))	= 127;
			//формирование размера
			(*(uint8_t*)(wsd + 2))	= (uint8_t)((wsz >> 56) & 0xFF);
			(*(uint8_t*)(wsd + 3))	= (uint8_t)((wsz >> 48) & 0xFF);
			(*(uint8_t*)(wsd + 4))	= (uint8_t)((wsz >> 40) & 0xFF);
			(*(uint8_t*)(wsd + 5))	= (uint8_t)((wsz >> 32) & 0xFF);
			(*(uint8_t*)(wsd + 6))	= (uint8_t)((wsz >> 24) & 0xFF);
			(*(uint8_t*)(wsd + 7))	= (uint8_t)((wsz >> 16) & 0xFF);
			(*(uint8_t*)(wsd + 8))	= (uint8_t)((wsz >> 8) & 0xFF);
			(*(uint8_t*)(wsd + 9))	= (uint8_t)(wsz & 0xFF);
			//pthread_mutex_lock(&BMPmutex);
			//wmutlock(mt);
			//while(cnt64 < wsz)
			//{
			//	dbyte   = (*(uint8_t*)(bd + cnt64));
				ad	= cnt64 + wsd + 10;
			//	if(dbyte != (*(uint8_t*)(ad)))
			//	{
					flg = 0xFF;
					//(*(uint8_t*)(ad))	= dbyte;
					memcpy(ad, bd, wsz);
			//	}
			//	cnt64++;
			//}
			//pthread_mutex_unlock(&BMPmutex);
			//printf("----wsz:%lli\n", wsz);
			//wmutunlock(mt);
			if(flg)
				return (wsz + 10);
		}
	}
	return 0;
} 

